Index: java/main/src/main/java/com/framsticks/gui/Browser.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/Browser.java	(revision 87)
+++ java/main/src/main/java/com/framsticks/gui/Browser.java	(revision 88)
@@ -2,21 +2,25 @@
 
 import com.framsticks.core.*;
-import com.framsticks.observers.Endpoint;
-import com.framsticks.observers.Observer;
+import com.framsticks.params.annotations.AutoAppendAnnotation;
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.annotations.ParamAnnotation;
 import com.framsticks.util.Logging;
+import com.framsticks.util.dispatching.AbstractJoinable;
 import com.framsticks.util.dispatching.Dispatcher;
+import com.framsticks.util.dispatching.Dispatching;
 import com.framsticks.util.dispatching.Future;
-
-import org.apache.commons.configuration.Configuration;
-import org.apache.commons.lang.ArrayUtils;
+import com.framsticks.util.dispatching.Joinable;
+import com.framsticks.util.dispatching.JoinableCollection;
+import com.framsticks.util.dispatching.JoinableParent;
+import com.framsticks.util.dispatching.JoinableState;
+
+import javax.swing.*;
+
 import org.apache.log4j.Logger;
-
-import javax.swing.*;
 
 import java.awt.Dimension;
 import java.util.ArrayList;
-import java.util.HashSet;
 import java.util.List;
-import java.util.Set;
+import java.util.Map;
 import com.framsticks.util.dispatching.RunAt;
 
@@ -24,13 +28,18 @@
  * @author Piotr Sniegowski
  */
-public class Browser extends Observer {
+@FramsClassAnnotation
+public class Browser extends AbstractJoinable implements Dispatcher<Browser>, Entity, JoinableParent {
 
 	private static final Logger log = Logger.getLogger(Browser.class.getName());
 
-	protected final Set<Frame> frames = new HashSet<Frame>();
+	protected JoinableCollection<Frame> frames = new JoinableCollection<Frame>().setObservableName("frames");
+	protected JoinableCollection<Instance> instances = new JoinableCollection<Instance>().setObservableName("instances");
+
 	protected MainFrame mainFrame;
 	public List<PanelProvider> panelProviders = new ArrayList<PanelProvider>();
 	protected Dimension defaultFrameDimension;
 
+	String name;
+
 	public void addFrame(Frame frame) {
 		frames.add(frame);
@@ -38,38 +47,13 @@
 
 	public Browser() {
+		setName("browser");
 		JPopupMenu.setDefaultLightWeightPopupEnabled(false);
 		addPanelProvider(new StandardPanelProvider());
-	}
-
-	@Override
-	public void configure(Configuration config) {
-		super.configure(config);
-
-		defaultFrameDimension = new Dimension(config.getInteger("size.width", 1000), config.getInteger("size.height", 500));
-
-		for (String name : config.getStringArray("panel_providers")) {
-			try {
-				Class<?> c = Class.forName(name);
-				if (ArrayUtils.indexOf(c.getInterfaces(), PanelProvider.class) == -1) {
-					continue;
-				}
-				PanelProvider p = (PanelProvider)c.newInstance();
-				addPanelProvider(p);
-			} catch (Exception e) {
-				log.error("failed to load PanelProvider " + name + ": " + e);
-			}
-		}
-
-		// for (final String path : config.getStringArray("resolve_paths")) {
-		//	invokeLater()
-		//	autoResolvePath(path, new Future<Path>() {
-		//		@Override
-		//		public void result(Path p, Exception e) {
-		//			Logging.log(log, "auto resolve path", path, e);
-		//		}
-		//	});
-		// }
-	}
-
+
+		mainFrame = new MainFrame(Browser.this);
+		addFrame(mainFrame);
+	}
+
+	@AutoAppendAnnotation
 	public void addPanelProvider(PanelProvider panelProvider) {
 		log.debug("added panel provider of type: " + panelProvider.getClass().getCanonicalName());
@@ -77,6 +61,12 @@
 	}
 
+	@AutoAppendAnnotation
+	public void addInstance(Instance instance) {
+		log.info("adding instance: " + instance);
+		instances.add(instance);
+	}
+
 	public void autoResolvePath(final String path, final Future<Path> future) {
-		final Instance i = endpoints.get("localhost").getInstance();
+		final Instance i = instances.get("localhost");
 		i.invokeLater(new RunAt<Instance>() {
 			@Override
@@ -110,9 +100,7 @@
 	}
 
-	@Override
-	public void run() {
-		super.run();
-
+	protected void firstTask() {
 		assert isActive();
+		log.info("executing first task");
 
 		try {
@@ -135,6 +123,4 @@
 		javax.swing.JFrame.setDefaultLookAndFeelDecorated(true);
 
-		mainFrame = new MainFrame(Browser.this);
-		addFrame(mainFrame);
 
 		for (Frame f : frames) {
@@ -142,13 +128,13 @@
 		}
 
-		for (final Endpoint e : getEndpoints().values()) {
-			e.invokeLater(new RunAt<Instance>() {
+		for (final Instance i : instances) {
+			i.invokeLater(new RunAt<Instance>() {
 				@Override
 				public void run() {
-					final Path p = e.getInstance().getRootPath();
+					final Path p = i.getRootPath();
 					invokeLater(new RunAt<Browser>() {
 						@Override
 						public void run() {
-							mainFrame.addRootPath((BrowserEndpoint) e, p);
+							mainFrame.addRootPath(p);
 						}
 					});
@@ -158,5 +144,5 @@
 
 		for (Frame f : frames) {
-			f.setVisible(true);
+			f.getSwing().setVisible(true);
 		}
 
@@ -169,37 +155,45 @@
 		//assert instance.isActive();
 
-
-/*
-		final TreeNode parentTreeNode = (TreeNode) child.getParent().getUserObject();
-		if (parentTreeNode == null) {
-			Dispatching.invokeDispatch(this, manager, new Runnable() {
-				@Override
-				public void run() {
-					createTreeNodeForChild(child);
-				}
-			});
-			return;
-		}
-		log.debug(child.getClass().getSimpleName() + " created: " + child);
-
-
-		invokeLater(new Runnable() {
+		/*
+		 final TreeNode parentTreeNode = (TreeNode) child.getParent().getUserObject();
+		 if (parentTreeNode == null) {
+		 Dispatching.invokeDispatch(this, manager, new Runnable() {
+		 @Override
+		 public void run() {
+		 createTreeNodeForChild(child);
+		 }
+		 });
+		 return;
+		 }
+		 log.debug(child.getClass().getSimpleName() + " created: " + child);
+
+
+		 invokeLater(new Runnable() {
+		 @Override
+		 public void run() {
+		 parentTreeNode.getOrCreateChildTreeNodeFor(child);
+		 }
+		 });
+		 */
+	}
+
+	@Override
+	protected void joinableStart() {
+		Dispatching.use(frames, this);
+		Dispatching.use(instances, this);
+
+		invokeLater(new RunAt<Browser>() {
 			@Override
 			public void run() {
-				parentTreeNode.getOrCreateChildTreeNodeFor(child);
+				firstTask();
 			}
 		});
-*/
-	}
-
-
-	@Override
-	protected Endpoint createEndpoint() {
-		return new BrowserEndpoint();
-	}
-
-	@Override
-	public Dispatcher<Entity> createDefaultDispatcher() {
-		return SwingDispatcher.getInstance();
+	}
+
+	/**
+	 * @return the instances
+	 */
+	public Map<String, Instance> getInstances() {
+		return instances.getObservables();
 	}
 
@@ -211,3 +205,66 @@
 	}
 
+	/**
+	 * @return the name
+	 */
+	@ParamAnnotation
+	public String getName() {
+		return name;
+	}
+
+	/**
+	 * @param name the name to set
+	 */
+	@ParamAnnotation
+	public void setName(String name) {
+		this.name = name;
+	}
+
+	@Override
+	public boolean isActive() {
+		return SwingDispatcher.getInstance().isActive();
+	}
+
+	@Override
+	public void invokeLater(RunAt<? extends Browser> runnable) {
+		SwingDispatcher.getInstance().invokeLater(runnable);
+	}
+
+	@Override
+	protected void joinableJoin() throws InterruptedException {
+		Dispatching.join(frames);
+		Dispatching.join(instances);
+		// super.join();
+	}
+
+	@Override
+	protected void joinableInterrupt() {
+		Dispatching.drop(frames, this);
+		Dispatching.drop(instances, this);
+	}
+
+	@Override
+	public void childChangedState(Joinable joinable, JoinableState state) {
+		if (joinable == frames) {
+			proceedToState(state);
+		}
+
+	}
+
+	@Override
+	protected void joinableFinish() {
+		// TODO Auto-generated method stub
+
+	}
+
+	@Override
+	public String toString() {
+		return getName();
+	}
+
+
+	// @Override
+	// public boolean isDone() {
+	//	return frames.isDone() && instances.isDone();
+	// }
 }
Index: java/main/src/main/java/com/framsticks/gui/Frame.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/Frame.java	(revision 87)
+++ java/main/src/main/java/com/framsticks/gui/Frame.java	(revision 88)
@@ -1,4 +1,5 @@
 package com.framsticks.gui;
 
+import com.framsticks.core.Entity;
 import com.framsticks.core.Instance;
 import com.framsticks.core.Path;
@@ -6,6 +7,9 @@
 import com.framsticks.gui.view.TreeCellRenderer;
 import com.framsticks.util.dispatching.Dispatcher;
+import com.framsticks.util.dispatching.JoinableCollection;
 import com.framsticks.util.lang.ScopeEnd;
 import com.framsticks.util.swing.KeyboardModifier;
+import com.framsticks.util.swing.MenuConstructor;
+
 import org.apache.log4j.Logger;
 
@@ -28,5 +32,5 @@
  */
 @SuppressWarnings("serial")
-public class Frame extends JFrame implements Dispatcher<Frame> {
+public class Frame extends JoinableCollection<Instance> implements Entity, Dispatcher<Frame> {
 
 	private static final Logger log = Logger.getLogger(Frame.class.getName());
@@ -34,10 +38,11 @@
 	protected final Browser browser;
 
-	protected final Dimension screenDimension = Toolkit.getDefaultToolkit()
-			.getScreenSize();
-
-	final protected CardLayout cardPanelLayout = new CardLayout();
-	protected final JPanel cardPanel = new JPanel();
-
+	protected final Dimension screenDimension = Toolkit.getDefaultToolkit().getScreenSize();
+
+	protected CardLayout cardPanelLayout;
+	protected JPanel cardPanel;
+
+	protected final String title;
+	protected JFrame swing;
 	protected JScrollPane treeScrollPane;
 	protected JTree tree;
@@ -63,20 +68,30 @@
 	protected JMenu helpMenu;
 
-	protected final Map<BrowserEndpoint, EndpointAtFrame> endpoints = new HashMap<BrowserEndpoint, EndpointAtFrame>();
-	protected final Map<Instance, EndpointAtFrame> endpointsByInstance = new HashMap<Instance, EndpointAtFrame>();
+	protected final Map<Instance, InstanceAtFrame> instancesAtFrames = new HashMap<Instance, InstanceAtFrame>();
 
 	public Frame(String title, Browser browser) {
-		super(title);
+		this.title = title;
+		this.browser = browser;
+	}
+
+	public void configure() {
+		swing = new JFrame(title);
+		swing.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
+		swing.addWindowListener(new WindowAdapter() {
+			@Override
+			public void windowClosing(WindowEvent e) {
+				log.info("received closing");
+				joinableFinish();
+			}
+		});
 		/** this is done to remove the current value label from above the slider,
 		 * because it cannot put to work properly with floating-point value sliders,
 		 * nor it can be removed in normal way through JSlider methods  */
 		UIManager.put("Slider.paintValue", false);
-		this.browser = browser;
 		log.debug("creating " + this);
-	}
-
-	public void configure() {
-
-		Container contentPane = this.getContentPane();
+
+		statusBar = new JLabel("not connected");
+
+		Container contentPane = swing.getContentPane();
 		contentPane.setLayout(new BorderLayout());
 
@@ -95,15 +110,12 @@
 		treePopupMenu.add(new JMenuItem("Refresh"));
 		treePopupMenu.add(new JMenuItem("Open in new frame as root"));
-		addNodeActionToTreePopupMenu("Copy path to clipboard",
-				new NodeAction() {
-					@Override
-					public void actionPerformed(TreeNode treeNode) {
-						Path path = treeNode.getInstancePath();
-						StringSelection selection = new StringSelection(path
-								.toString());
-						getToolkit().getSystemClipboard().setContents(
-								selection, selection);
-					}
-				});
+		addNodeActionToTreePopupMenu("Copy path to clipboard", new NodeAction() {
+			@Override
+			public void actionPerformed(TreeNode treeNode) {
+				Path path = treeNode.getInstancePath();
+				StringSelection selection = new StringSelection(path.toString());
+				swing.getToolkit().getSystemClipboard().setContents(selection, selection);
+			}
+		});
 		//this.add(createMenuItem("Add to favourites", null));
 		//this.add(createMenuItem("Remove from favourites", null));
@@ -171,10 +183,5 @@
 		});
 
-		new KeyboardModifier(tree, JComponent.WHEN_FOCUSED)
-			.join(KeyStroke.getKeyStroke('h'), KeyStroke.getKeyStroke(KeyEvent.VK_LEFT, 0))
-			.join(KeyStroke.getKeyStroke('j'), KeyStroke.getKeyStroke(KeyEvent.VK_DOWN, 0))
-			.join(KeyStroke.getKeyStroke('k'), KeyStroke.getKeyStroke(KeyEvent.VK_UP, 0))
-			.join(KeyStroke.getKeyStroke('l'), KeyStroke.getKeyStroke(KeyEvent.VK_RIGHT, 0))
-			;
+		new KeyboardModifier(tree, JComponent.WHEN_FOCUSED).join(KeyStroke.getKeyStroke('h'), KeyStroke.getKeyStroke(KeyEvent.VK_LEFT, 0)).join(KeyStroke.getKeyStroke('j'), KeyStroke.getKeyStroke(KeyEvent.VK_DOWN, 0)).join(KeyStroke.getKeyStroke('k'), KeyStroke.getKeyStroke(KeyEvent.VK_UP, 0)).join(KeyStroke.getKeyStroke('l'), KeyStroke.getKeyStroke(KeyEvent.VK_RIGHT, 0));
 
 		tree.setCellRenderer(new TreeCellRenderer());
@@ -214,12 +221,13 @@
 		leftPanel.setLayout(new BorderLayout());
 		//leftPanel.add(new ViewerTest(), BorderLayout.PAGE_START);
-//        JPanel leftTopPanel = createLeftTopPanel();
-//        if (leftTopPanel != null) {
-//            leftPanel.add(leftTopPanel, BorderLayout.PAGE_START);
-//        }
+		//        JPanel leftTopPanel = createLeftTopPanel();
+		//        if (leftTopPanel != null) {
+		//            leftPanel.add(leftTopPanel, BorderLayout.PAGE_START);
+		//        }
 		leftPanel.add(treePanel, BorderLayout.CENTER);
 		leftPanel.setBackground(Color.WHITE);
 		leftPanel.setForeground(Color.WHITE);
 
+		cardPanel = new JPanel();
 		cardPanel.setName("card");
 		JSplitPane split = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, leftPanel, cardPanel);
@@ -236,10 +244,18 @@
 		mainPanelLayout.show(mainPanel, "browser");
 
+		cardPanelLayout = new CardLayout();
 		cardPanel.setLayout(cardPanelLayout);
 
-		this.pack();
+		swing.pack();
 		tree.requestFocusInWindow();
 
-		log.debug("frame configured");
+		log.debug("frame configured: " + this);
+
+		new MenuConstructor(fileMenu).add(KeyStroke.getKeyStroke(KeyEvent.VK_O, ActionEvent.CTRL_MASK), new AbstractAction("Close") {
+			@Override
+			public void actionPerformed(ActionEvent actionEvent) {
+				interrupt();
+			}
+		});
 
 	}
@@ -249,12 +265,12 @@
 	}
 
-	public void addRootPath(BrowserEndpoint endpoint, Path path) {
-		assert isActive();
-		assert !endpoints.containsKey(endpoint);
-
-		EndpointAtFrame e = new EndpointAtFrame(endpoint, this);
-		endpoint.getInstance().addListener(e);
-		endpoints.put(endpoint, e);
-		endpointsByInstance.put(endpoint.getInstance(), e);
+	public void addRootPath(Path path) {
+		assert isActive();
+		Instance instance = path.getInstance();
+		assert browser.getInstances().containsValue(instance);
+
+		InstanceAtFrame e = new InstanceAtFrame(instance, this);
+		instance.addListener(e);
+		instancesAtFrames.put(instance, e);
 		TreeNode node = new TreeNode(e, path);
 		e.rootTreeNode = node;
@@ -299,5 +315,4 @@
 	}
 
-
 	private void showPopup(MouseEvent e) {
 		assert isActive();
@@ -314,9 +329,15 @@
 	}
 
+	/**
+	 * @return the swing
+	 */
+	public JFrame getSwing() {
+		return swing;
+	}
+
 	public TreeNode getCurrentlyPoppedTreeNode() {
 		assert isActive();
 		return currentlyPoppedTreeNode;
 	}
-
 
 	public void clear() {
@@ -342,11 +363,11 @@
 	public void selectTreeNode(final TreeNode treeNode) {
 		assert isActive();
-/*		final Panel panel = treeNode.getOrCreatePanel();
-		if (panel == null) {
-			return;
-		}
-		panel.setCurrentTreeNode(treeNode);
-		treeNode.updateData();
-		showPanel(panel);*/
+		/*		final Panel panel = treeNode.getOrCreatePanel();
+		 if (panel == null) {
+		 return;
+		 }
+		 panel.setCurrentTreeNode(treeNode);
+		 treeNode.updateData();
+		 showPanel(panel);*/
 	}
 
@@ -359,5 +380,5 @@
 			return null;
 		}
-		return (TreeNode)treePath.getLastPathComponent();
+		return (TreeNode) treePath.getLastPathComponent();
 	}
 
@@ -373,5 +394,5 @@
 	public void goTo(Path path) {
 		assert isActive();
-		final TreePath treePath = endpointsByInstance.get(path.getInstance()).getTreePath(path, false);
+		final TreePath treePath = instancesAtFrames.get(path.getInstance()).getTreePath(path, false);
 		log.info("go to path: " + path + "(" + treePath + ")");
 
@@ -388,5 +409,4 @@
 	}
 
-
 	public void addNode(TreeNode child, DefaultMutableTreeNode parent) {
 		assert isActive();
@@ -399,6 +419,38 @@
 	@Override
 	public String toString() {
-		return getTitle() + "@" + browser.getName();
-	}
+		return title + "@" + browser.getName();
+	}
+
+	@Override
+	protected void joinableInterrupt() {
+		assert isActive();
+		super.joinableInterrupt();
+
+		invokeLater(new RunAt<Frame>() {
+			@Override
+			public void run() {
+				finish();
+			}
+		});
+	}
+
+	@Override
+	protected void joinableFinish() {
+		assert isActive();
+		log.debug("disposing frame " + this);
+		swing.dispose();
+	}
+
+	// @Override
+	// public boolean isDone() {
+	//	return super.isDone() && !swing.isDisplayable();
+	// }
+
+
+	@Override
+	public String getName() {
+		return title;
+	}
+
 
 }
Index: java/main/src/main/java/com/framsticks/gui/InstanceAtFrame.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/InstanceAtFrame.java	(revision 88)
+++ java/main/src/main/java/com/framsticks/gui/InstanceAtFrame.java	(revision 88)
@@ -0,0 +1,180 @@
+package com.framsticks.gui;
+
+import org.apache.log4j.Logger;
+
+import com.framsticks.core.Instance;
+import com.framsticks.core.InstanceListener;
+import com.framsticks.core.ListChange;
+import com.framsticks.core.Node;
+import com.framsticks.core.Path;
+import com.framsticks.params.CompositeParam;
+import com.framsticks.params.FramsClass;
+
+import java.util.*;
+
+import javax.swing.tree.TreePath;
+import com.framsticks.util.dispatching.RunAt;
+
+/**
+ * @author Piotr Sniegowski
+ */
+public class InstanceAtFrame implements InstanceListener {
+
+	private static final Logger log = Logger.getLogger(InstanceAtFrame.class);
+
+	protected final Frame frame;
+	protected final Instance instance;
+	protected final Map<String, Panel> knownPanels = new HashMap<String, Panel>();
+	protected TreeNode rootTreeNode;
+
+	public InstanceAtFrame(Instance instance, Frame frame) {
+		this.frame = frame;
+		this.instance = instance;
+	}
+
+	public Frame getFrame() {
+		return frame;
+	}
+
+	/**
+	 * @return the instance
+	 */
+	public Instance getInstance() {
+		return instance;
+	}
+
+	public void registerPanel(Panel panel) {
+	}
+
+	public Panel findPanel(String accessId) {
+		assert frame.isActive();
+		return (knownPanels.containsKey(accessId) ? knownPanels.get(accessId) : null);
+	}
+
+	public final String getName() {
+		return instance.getName();
+	}
+
+	public Panel preparePanel(CompositeParam param, FramsClass framsClass) {
+		assert frame.isActive();
+		Panel panel = preparePanelImpl(param, framsClass);
+		assert panel != null;
+		String accessId = param.computeAccessId();
+		panel.uniqueName = accessId + "@" + instance.getName();
+		knownPanels.put(accessId, panel);
+		frame.cardPanel.add(panel, panel.uniqueName);
+		log.debug("prepared panel for " + panel);
+		return panel;
+	}
+
+	protected Panel preparePanelImpl(CompositeParam param, FramsClass framsClass) {
+		assert frame.isActive();
+		List<Panel> panels = new ArrayList<Panel>();
+
+		Panel.Parameters parameters = new Panel.Parameters(this, param,
+				framsClass);
+		for (PanelProvider pp : frame.browser.panelProviders) {
+			Panel p = pp.providePanel(parameters);
+			if (p != null) {
+				panels.add(p);
+			}
+		}
+
+		if (panels.isEmpty()) {
+			return new EmptyPanel(parameters);
+		}
+		if (panels.size() == 1) {
+			return panels.get(0);
+		}
+		return new MultiPanel(parameters, panels);
+
+	}
+
+	@Override
+	public void onListChange(Path path, ListChange change) {
+
+	}
+
+	public TreePath getTreePath(Path path, boolean create) {
+		assert frame.isActive();
+		TreeNode t = rootTreeNode;
+		TreePath result = new TreePath(frame.rootNode).pathByAddingChild(rootTreeNode);
+		List<Node> nodes = path.getNodes();
+		Iterator<Node> i = nodes.iterator();
+		i.next();
+		// Node first = i.next();
+
+		// if (!t.path.isResolved()) {
+		//	t.path = new Path(path.getInstance(), nodes, first);
+		// }
+		while (i.hasNext()) {
+			Node n = i.next();
+			TreeNode r = null;
+			for (TreeNode c : t.childrenIterable()) {
+				if (c.paramId.equals(n.getParam().getId())) {
+					r = c;
+					break;
+				}
+			}
+			if (r == null) {
+				log.debug("missing " + n.getParam().getId() + " in " + t);
+				if (!create) {
+					return result;
+				}
+				Path p = Path.build().instance(path.getInstance()).buildUpTo(nodes, n).finish();
+
+
+				log.debug("forced resolution: creating treenode for " + p);
+				TreeNode childNode = new TreeNode(InstanceAtFrame.this, p);
+
+				frame.addNode(childNode, t);
+				// frame.treeModel.reload();
+				// t.add(childNode);
+				// frame.treeModel.nodeStructureChanged(t);
+
+				r = childNode;
+			} else {
+				// if (!r.path.isResolved()) {
+				//	r.path = new Path(path.getInstance(), nodes, n);
+				// }
+			}
+			result = result.pathByAddingChild(r);
+			t = r;
+		}
+		return result;
+	}
+
+	@Override
+	public void onFetch(final Path path) {
+		assert instance.isActive();
+		log.trace("fetched " + path);
+
+		frame.invokeLater(new RunAt<Frame>() {
+			@Override
+			public void run() {
+
+				TreePath treePath = getTreePath(path, true);
+				assert treePath.getPathCount() == path.size() + 1;
+
+				final TreeNode result = (TreeNode) treePath.getLastPathComponent();
+				// log.trace("found " + result + " == " + path);
+				instance.invokeLater(new RunAt<Instance>() {
+					@Override
+					public void run() {
+						result.reactForFetchResult(path, null);
+					}
+				});
+			}
+		});
+	}
+
+	@Override
+	public void onRun(Exception e) {
+
+	}
+
+	@Override
+	public void onStop(Exception e) {
+
+	}
+}
Index: java/main/src/main/java/com/framsticks/gui/MainFrame.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/MainFrame.java	(revision 87)
+++ java/main/src/main/java/com/framsticks/gui/MainFrame.java	(revision 88)
@@ -28,8 +28,7 @@
 	 */
 	public MainFrame(final Browser browser) {
-		super("Framsticks Network Client", browser);
+		super("framsticks", browser);
 		log.debug("creating main frame");
 
-		statusBar = new JLabel("not connected");
 	}
 
@@ -234,14 +233,14 @@
 	private void setFrameProperties() {
 		assert isActive();
-		setMinimumSize(this.getPreferredSize());
-		setSize(this.getPreferredSize());
-		setMaximumSize(screenDimension);
-		setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
-
-		setIconImage(ImageProvider.loadImage(ImageProvider.LOGO)
+		swing.setMinimumSize(swing.getPreferredSize());
+		swing.setSize(swing.getPreferredSize());
+		swing.setMaximumSize(screenDimension);
+		swing.setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
+
+		swing.setIconImage(ImageProvider.loadImage(ImageProvider.LOGO)
 				.getImage());
 
 
-		addWindowListener(new WindowAdapter() {
+		swing.addWindowListener(new WindowAdapter() {
 			public void windowClosing(WindowEvent e) {
 				assert isActive();
@@ -252,5 +251,5 @@
 				*/
 				onWindowClosing();
-				dispose();
+				swing.dispose();
 			}
 		});
Index: java/main/src/main/java/com/framsticks/gui/MultiPanel.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/MultiPanel.java	(revision 87)
+++ java/main/src/main/java/com/framsticks/gui/MultiPanel.java	(revision 88)
@@ -24,5 +24,5 @@
 		for (Panel p : panels) {
 			assert p.getClassName().equals(getClassName());
-			assert p.getEndpointAtFrame() == getEndpointAtFrame();
+			assert p.getInstanceAtFrame() == getInstanceAtFrame();
 			tabbedPane.add(p.getTitle(), p);
 		}
Index: java/main/src/main/java/com/framsticks/gui/Panel.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/Panel.java	(revision 87)
+++ java/main/src/main/java/com/framsticks/gui/Panel.java	(revision 88)
@@ -15,10 +15,10 @@
 
 	public static class Parameters {
-		public final EndpointAtFrame endpoint;
+		public final InstanceAtFrame instanceAtFrame;
 		public final CompositeParam param;
 		public final FramsClass framsClass;
 
-		public Parameters(EndpointAtFrame endpoint, CompositeParam param, FramsClass framsClass) {
-			this.endpoint = endpoint;
+		public Parameters(InstanceAtFrame instanceAtFrame, CompositeParam param, FramsClass framsClass) {
+			this.instanceAtFrame = instanceAtFrame;
 			this.param = param;
 			this.framsClass = framsClass;
@@ -29,5 +29,5 @@
 
 	protected TreeNode currentTreeNode;
-	protected final EndpointAtFrame endpoint;
+	protected final InstanceAtFrame instanceAtFrame;
 	protected final Frame frame;
 	protected final String className;
@@ -37,6 +37,6 @@
 
 	public Panel(Parameters parameters) {
-		this.endpoint = parameters.endpoint;
-		this.frame = parameters.endpoint.getFrame();
+		this.instanceAtFrame = parameters.instanceAtFrame;
+		this.frame = parameters.instanceAtFrame.getFrame();
 		this.framsClass = parameters.framsClass;
 		this.param = parameters.param;
@@ -57,6 +57,6 @@
 	}
 
-	public final EndpointAtFrame getEndpointAtFrame() {
-		return endpoint;
+	public final InstanceAtFrame getInstanceAtFrame() {
+		return instanceAtFrame;
 	}
 
Index: java/main/src/main/java/com/framsticks/gui/StandardPanelProvider.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/StandardPanelProvider.java	(revision 87)
+++ java/main/src/main/java/com/framsticks/gui/StandardPanelProvider.java	(revision 88)
@@ -22,5 +22,5 @@
 		}
 //		if (param instanceof ListParam) {
-//			return new ListPanel(endpoint);
+//			return new ListPanel();
 //		}
 		return null;
Index: java/main/src/main/java/com/framsticks/gui/TreeNode.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/TreeNode.java	(revision 87)
+++ java/main/src/main/java/com/framsticks/gui/TreeNode.java	(revision 88)
@@ -41,5 +41,5 @@
 
 	final protected Frame frame;
-	final protected EndpointAtFrame endpoint;
+	final protected InstanceAtFrame instanceAtFrame;
 
 	final protected Map<EventParam, Subscription<?>> userSubscriptions = new HashMap<>();
@@ -51,6 +51,6 @@
 	protected Path path;
 
-	public TreeNode(EndpointAtFrame endpoint, final Path path) {
-		this.frame = endpoint.getFrame();
+	public TreeNode(InstanceAtFrame instanceAtFrame, final Path path) {
+		this.frame = instanceAtFrame.getFrame();
 		assert frame.isActive();
 		this.paramId = path.getLastElement();
@@ -58,5 +58,5 @@
 		log.debug("creating treenode " + name + ": " + path);
 		this.path = path;
-		this.endpoint = endpoint;
+		this.instanceAtFrame = instanceAtFrame;
 
 		iconName = TreeCellRenderer.findIconName(name, path.getTextual());
@@ -171,5 +171,5 @@
 						}
 						log.debug("update: treenode for " + p);
-						TreeNode childNode = new TreeNode(endpoint, childPath);
+						TreeNode childNode = new TreeNode(instanceAtFrame, childPath);
 
 						frame.addNode(childNode, TreeNode.this);
@@ -336,5 +336,5 @@
 
 		CompositeParam param = path.getTop().getParam();
-		panel = endpoint.findPanel(param.computeAccessId());
+		panel = instanceAtFrame.findPanel(param.computeAccessId());
 		if (panel != null) {
 			log.debug("found prepared panel for: " + path);
@@ -353,5 +353,5 @@
 					@Override
 					public void run() {
-						panel = endpoint.preparePanel(param, framsClass);
+						panel = instanceAtFrame.preparePanel(param, framsClass);
 						fillPanelWithValues();
 					}
@@ -503,5 +503,5 @@
 		final Map<ValueControl, Object> changes = localChanges;
 		localChanges = null;
-		endpoint.getEndpoint().invokeLater(new RunAt<Instance>() {
+		instanceAtFrame.getInstance().invokeLater(new RunAt<Instance>() {
 			@Override
 			public void run() {
@@ -509,5 +509,5 @@
 					final ValueControl key = e.getKey();
 					final Path p = path;
-					endpoint.getEndpoint().getInstance().storeValue(p, e.getKey().getParam(), e.getValue(), new StateFunctor() {
+					instanceAtFrame.getInstance().storeValue(p, e.getKey().getParam(), e.getValue(), new StateFunctor() {
 						@Override
 						public void call(Exception e) {
Index: java/main/src/main/java/com/framsticks/hosting/InstanceClient.java
===================================================================
--- java/main/src/main/java/com/framsticks/hosting/InstanceClient.java	(revision 87)
+++ java/main/src/main/java/com/framsticks/hosting/InstanceClient.java	(revision 88)
@@ -10,5 +10,10 @@
 import com.framsticks.parsers.Savers;
 import com.framsticks.core.LocalInstance;
+import com.framsticks.util.dispatching.AbstractJoinable;
+import com.framsticks.util.dispatching.Dispatching;
 import com.framsticks.util.dispatching.Future;
+import com.framsticks.util.dispatching.Joinable;
+import com.framsticks.util.dispatching.JoinableParent;
+import com.framsticks.util.dispatching.JoinableState;
 
 import java.net.Socket;
@@ -21,5 +26,5 @@
  * @author Piotr Sniegowski
  */
-public class InstanceClient implements RequestHandler {
+public class InstanceClient extends AbstractJoinable implements RequestHandler, JoinableParent {
 
 	protected final LocalInstance instance;
@@ -29,5 +34,4 @@
 		this.instance = instance;
 		connection = new ServerConnection(socket, this);
-		connection.start();
 	}
 
@@ -36,5 +40,4 @@
 		return instance + "|" + connection.toString();
 	}
-
 
 	@Override
@@ -94,3 +97,28 @@
 
 	}
+
+	@Override
+	protected void joinableStart() {
+		Dispatching.use(connection, this);
+	}
+
+	@Override
+	protected void joinableInterrupt() {
+		Dispatching.drop(connection, this);
+	}
+
+	@Override
+	protected void joinableFinish() {
+	}
+
+	@Override
+	protected void joinableJoin() throws InterruptedException {
+		Dispatching.join(connection);
+	}
+
+	@Override
+	public void childChangedState(Joinable joinable, JoinableState state) {
+		proceedToState(state);
+	}
+
 }
